bboard/api/urls.py
from django.urls import path

from .views import bbs, BbDetailView, comments

urlpatterns = [
    path('bbs/<int:pk>/comments/', comments),
    path('bbs/<int:pk>/', BbDetailView.as_view()),
    path('bbs/', bbs),
]

bboard/bboard/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf import settings
from django.contrib.staticfiles.views import serve
from django.views.decorators.cache import never_cache
from django.conf.urls.static import static


urlpatterns = [
    path('admin/', admin.site.urls),
    path('captcha/', include('captcha.urls')),
    path('api/', include('api.urls')),
    path('', include('main.urls')),
]
if settings.DEBUG:
    urlpatterns.append(path('static/<path:path>', never_cache(serve)))
    urlpatterns += static(settings.MEDIA_URL,
                          document_root=settings.MEDIA_ROOT)

bboard/main/urls.py
from django.urls import path

from.views import profile, BBLogoutView, BBLoginView, index, other_page, ChangeUserInfoView, BBPasswordChangeView, \
RegisterUserView, RegisterDoneView, user_activate, DeleteUserView,  BBPasswordResetView, \
BBPasswordResetDoneView, BBPasswordResetConfirmView, BBPasswordResetCompleteView, by_rubric, detail,  \
profile_bb_detail, profile_bb_add, profile_bb_change, profile_bb_delete




app_name = 'main'
urlpatterns = [
    path('accounts/register/activate/<str:sign>/', user_activate,
         name='register_activate'),
    path('accounts/register/done/', RegisterDoneView.as_view(),
         name='register_done'),
    path('accounts/register/', RegisterUserView.as_view(), name='register'),
    path('accounts/logout/', BBLogoutView.as_view(), name='logout'),
    path('accounts/password/change/', BBPasswordChangeView.as_view(),
         name='password_change'),
    path('accounts/profile/delete/', DeleteUserView.as_view(),
         name='profile_delete'),
    path('accounts/profile/change/', ChangeUserInfoView.as_view(),
         name='profile_change'),
    path('accounts/profile/change/<int:pk>/', profile_bb_change,
         name='profile_bb_change'),
    path('accounts/profile/delete/<int:pk>/', profile_bb_delete,
         name='profile_bb_delete'),
    path('accounts/profile/add/', profile_bb_add, name='profile_bb_add'),
    path('accounts/profile/<int:pk>/', profile_bb_detail,
         name='profile_bb_detail'),
    path('accounts/profile/', profile, name='profile'),
    path('accounts/password/reset/done/', BBPasswordResetDoneView.as_view(),
         name='password_reset_done'),
    path('accounts/password/reset/', BBPasswordResetView.as_view(),
         name='password_reset'),
    path('accounts/password/confirm/complete/',
         BBPasswordResetCompleteView.as_view(),
         name='password_reset_complete'),
    path('accounts/password/confirm/<uidb64>/<token>/',
         BBPasswordResetConfirmView.as_view(),
         name='password_reset_confirm'),
    path('accounts/login/', BBLoginView.as_view(), name='login'),
    path('<int:rubric_pk>/<int:pk>/', detail, name='detail'),
    path('<int:pk>/', by_rubric, name='by_rubric'),
    path('<str:page>/', other_page, name='other'),
    path('', index, name='index'),
]

bboard/main/forms.py
from django import forms
from django.contrib.auth import password_validation
from django.core.exceptions import ValidationError
from django.forms import inlineformset_factory
from captcha.fields import CaptchaField

from .models import AdvUser,SuperRubric, SubRubric, Bb, AdditionalImage, Comment
from .apps import user_registered

class ChangeUserInfoForm(forms.ModelForm):
    email = forms.EmailField(required=True, label='Адрес электронной почты')

    class Meta:
        model = AdvUser
        fields = ('username', 'email', 'first_name', 'last_name',
                  'send_messages')

class RegisterUserForm(forms.ModelForm):
    email = forms.EmailField(required=True, label='Адрес электронной почты')
    password1 = forms.CharField(label='Пароль', widget=forms.PasswordInput,
      help_text=password_validation.password_validators_help_text_html())
    password2 = forms.CharField(label='Пароль (повторно)',
      widget=forms.PasswordInput,
      help_text='Введите тот же самый пароль еще раз для проверки')

    def clean_password1(self):
        password1 = self.cleaned_data['password1']
        if password1:
            password_validation.validate_password(password1)
        return password1

    def clean(self):
        super().clean()
        password1 = self.cleaned_data['password1']
        password2 = self.cleaned_data['password2']
        if password1 and password2 and password1 != password2:
            errors = {'password2': ValidationError(
              'Введенные пароли не совпадают', code='password_mismatch')}
            raise ValidationError(errors)

    def save(self, commit=True):
        user = super().save(commit=False)
        user.set_password(self.cleaned_data['password1'])
        user.is_active = False
        user.is_activated = False
        if commit:
            user.save()
        user_registered.send(RegisterUserForm, instance=user)
        return user

    class Meta:
        model = AdvUser
        fields = ('username', 'email', 'password1', 'password2',
                  'first_name', 'last_name', 'send_messages')

class SubRubricForm(forms.ModelForm):
    super_rubric = forms.ModelChoiceField(queryset=SuperRubric.objects.all(),
                                        empty_label=None, label='Надрубрика',
                                        required=True)

    class Meta:
        model = SubRubric
        fields = '__all__'

class SearchForm(forms.Form):
    keyword = forms.CharField(required=False, max_length=20, label='')

class BbForm(forms.ModelForm):
    class Meta:
        model = Bb
        fields = '__all__'
        widgets = {'author': forms.HiddenInput}

AIFormSet = inlineformset_factory(Bb, AdditionalImage, fields='__all__')

class UserCommentForm(forms.ModelForm):
    class Meta:
        model = Comment
        exclude = ('is_active',)
        widgets = {'bb': forms.HiddenInput}

class GuestCommentForm(forms.ModelForm):
    captcha = CaptchaField(label='Введите текст с картинки',
              error_messages={'invalid': 'Неправильный текст'})

    class Meta:
        model = Comment
        exclude = ('is_active',)
        widgets = {'bb': forms.HiddenInput}

bboard/main/views.py
from django.shortcuts import render, get_object_or_404, redirect
from django.http import HttpResponse, Http404
from django.template import TemplateDoesNotExist
from django.template.loader import get_template
from django.contrib.auth.views import LoginView, LogoutView, \
    PasswordChangeView, PasswordResetView, PasswordResetDoneView, \
    PasswordResetConfirmView, PasswordResetCompleteView
from django.contrib.auth.decorators import login_required
from django.contrib.auth.mixins import LoginRequiredMixin
from django.views.generic.edit import UpdateView, CreateView, \
    DeleteView
from django.contrib.messages.views import SuccessMessageMixin
from django.urls import reverse_lazy
from django.views.generic.base import TemplateView
from django.core.signing import BadSignature
from django.contrib.auth import logout
from django.contrib import messages
from django.core.paginator import Paginator

from .models import AdvUser, SubRubric, Bb, Comment
from .forms import ChangeUserInfoForm, RegisterUserForm, SearchForm, \
BbForm, AIFormSet, UserCommentForm, GuestCommentForm
from .utilities import signer
from django.db.models import Q




def index(request):
    bbs = Bb.objects.filter(is_active=True)[:10]
    context = {'bbs': bbs}
    return render(request, 'main/index.html', context)

def other_page(request, page):
    try:
        template = get_template('main/' + page + '.html')
    except TemplateDoesNotExist:
        raise Http404
    return HttpResponse(template.render(request=request))

class BBLoginView(LoginView):
    template_name = 'main/login.html'

@login_required
def profile(request):
    return render(request, 'main/profile.html')

class BBLogoutView(LoginRequiredMixin, LogoutView):
    template_name = 'main/logout.html'

class ChangeUserInfoView(SuccessMessageMixin, LoginRequiredMixin,
                                              UpdateView):
    model = AdvUser
    template_name = 'main/change_user_info.html'
    form_class = ChangeUserInfoForm
    success_url = reverse_lazy('main:profile')
    success_message = 'Данные пользователя изменены'

    def setup(self, request, *args, **kwargs):
        self.user_id = request.user.pk
        return super().setup(request, *args, **kwargs)

    def get_object(self, queryset=None):
        if not queryset:
            queryset = self.get_queryset()
        return get_object_or_404(queryset, pk=self.user_id)

class BBPasswordChangeView(SuccessMessageMixin, LoginRequiredMixin,
                                                PasswordChangeView):
    template_name = 'main/password_change.html'
    success_url = reverse_lazy('main:profile')
    success_message = 'Пароль пользователя изменен'

class RegisterUserView(CreateView):
    model = AdvUser
    template_name = 'main/register_user.html'
    form_class = RegisterUserForm
    success_url = reverse_lazy('main:register_done')

class RegisterDoneView(TemplateView):
    template_name = 'main/register_done.html'

def user_activate(request, sign):
    try:
        username = signer.unsign(sign)
    except BadSignature:
        return render(request, 'main/bad_signature.html')
    user = get_object_or_404(AdvUser, username=username)
    if user.is_activated:
        template = 'main/user_is_activated.html'
    else:
        template = 'main/activation_done.html'
        user.is_active = True
        user.is_activated = True
        user.save()
    return render(request, template)

class DeleteUserView(LoginRequiredMixin, DeleteView):
    model = AdvUser
    template_name = 'main/delete_user.html'
    success_url = reverse_lazy('main:index')

    def setup(self, request, *args, **kwargs):
        self.user_id = request.user.pk
        return super().setup(request, *args, **kwargs)

    def post(self, request, *args, **kwargs):
        logout(request)
        messages.add_message(request, messages.SUCCESS, 'Пользователь удален')
        return super().post(request, *args, **kwargs)

    def get_object(self, queryset=None):
        if not queryset:
            queryset = self.get_queryset()
        return get_object_or_404(queryset, pk=self.user_id)


class BBPasswordResetView(PasswordResetView):
    template_name = 'main/password_reset.html'
    subject_template_name = 'email/reset_letter_subject.txt'
    email_template_name = 'email/reset_letter_body.txt'
    success_url = reverse_lazy('main:password_reset_done')

class BBPasswordResetDoneView(PasswordResetDoneView):
    template_name = 'main/password_reset_done.html'

class BBPasswordResetConfirmView(PasswordResetConfirmView):
    template_name = 'main/password_confirm.html'
    success_url = reverse_lazy('main:password_reset_complete')

class BBPasswordResetCompleteView(PasswordResetCompleteView):
    template_name = 'main/password_complete.html'

def by_rubric(request, pk):
    rubric = get_object_or_404(SubRubric, pk=pk)
    bbs = Bb.objects.filter(is_active=True, rubric=pk)
    if 'keyword' in request.GET:
        keyword = request.GET['keyword']
        q = Q(title__icontains=keyword) | Q(content__icontains=keyword)
        bbs = bbs.filter(q)
    else:
        keyword = ''
    form = SearchForm(initial={'keyword': keyword})
    paginator = Paginator(bbs, 2)
    if 'page' in request.GET:
        page_num = request.GET['page']
    else:
        page_num = 1
    page = paginator.get_page(page_num)
    context = {'rubric': rubric, 'page': page, 'bbs': page.object_list,
               'form': form}
    return render(request, 'main/by_rubric.html', context)

def detail(request, rubric_pk, pk):
    bb = Bb.objects.get(pk=pk)
    ais = bb.additionalimage_set.all()
    comments = Comment.objects.filter(bb=pk, is_active=True)
    initial = {'bb': bb.pk}
    if request.user.is_authenticated:
        initial['author'] = request.user.username
        form_class = UserCommentForm
    else:
        form_class = GuestCommentForm
    form = form_class(initial=initial)
    if request.method == 'POST':
        c_form = form_class(request.POST)
        if c_form.is_valid():
            c_form.save()
            messages.add_message(request, messages.SUCCESS,
                                 'Комментарий добавлен')
        else:
            form = c_form
            messages.add_message(request, messages.WARNING,
                                 'Комментарий не добавлен')
    context = {'bb': bb, 'ais': ais, 'comments': comments, 'form': form}
    return render(request, 'main/detail.html', context)

@login_required
def profile_bb_detail(request, pk):
    bb = get_object_or_404(Bb, pk=pk)
    ais = bb.additionalimage_set.all()
    context = {'bb': bb, 'ais': ais }
    return render(request, 'main/profile_bb_detail.html', context)

@login_required
def profile_bb_add(request):
    if request.method == 'POST':
        form = BbForm(request.POST, request.FILES)
        if form.is_valid():
            bb = form.save()
            formset = AIFormSet(request.POST, request.FILES, instance=bb)
            if formset.is_valid():
                formset.save()
                messages.add_message(request, messages.SUCCESS,
                                     'Объявление добавлено')
                return redirect('main:profile')
    else:
        form = BbForm(initial={'author': request.user.pk})
        formset = AIFormSet()
    context = {'form': form, 'formset': formset}
    return render(request, 'main/profile_bb_add.html', context)

@login_required
def profile_bb_change(request, pk):
    bb = get_object_or_404(Bb, pk=pk)
    if request.method == 'POST':
        form = BbForm(request.POST, request.FILES, instance=bb)
        if form.is_valid():
            bb = form.save()
            formset = AIFormSet(request.POST, request.FILES, instance=bb)
            if formset.is_valid():
                formset.save()
                messages.add_message(request, messages.SUCCESS,
                                     'Объявление исправлено')
                return redirect('main:profile')
    else:
        form = BbForm(instance=bb)
        formset = AIFormSet(instance=bb)
    context = {'form': form, 'formset': formset}
    return render(request, 'main/profile_bb_change.html', context)

@login_required
def profile_bb_delete(request, pk):
    bb = get_object_or_404(Bb, pk=pk)
    if request.method == 'POST':
        bb.delete()
        messages.add_message(request, messages.SUCCESS, 'Объявление удалено')
        return redirect('main:profile')
    else:
        context = {'bb': bb}
        return render(request, 'main/profile_bb_delete.html', context)

bboard/main/templates/main/bad_signature.html
{% extends "layout/basic.html" %}

{% block title %}Ошибка при активации{% endblock %}

{% block content %}
<h2>Активация</h2>
<p>Активация пользователя с таким именем прошла неудачно.</p>
<p><a href="{% url 'main:register' %}">Зарегистрироваться повторно</a></p>
{% endblock %}

bboard/main/templates/main/by_rubric.html
{% extends "layout/basic.html" %}

{% load thumbnail %}
{% load static %}
{% load bootstrap4 %}

{% block title %}{{ rubric }}{% endblock %}

{% block content %}
<h2 class="mb-2">{{ rubric }}</h2>
<div class="container-fluid mb-2">
    <div class="row">
        <div class="col">&nbsp;</div>
        <form class="col-md-auto form-inline">
            {% bootstrap_form form show_label=False %}
            {% bootstrap_button content='Искать' button_type='submit' %}
        </form>
    </div>
</div>
{% if bbs %}
<ul class="list-unstyled">
    {% for bb in bbs %}
    <li class="media my-5 p-3 border">
        {% url 'main:detail' rubric_pk=rubric.pk pk=bb.pk as url %}
        <a href="{{ url }}{{ all }}">
        {% if bb.image %}
        <img class="mr-3" src="{% thumbnail bb.image 'default' %}">
        {% else %}
        <img class="mr-3" src="{% static 'main/empty.jpg' %}">
        {% endif %}
        </a>
        <div class="media-body">
          <h3><a href="{{ url }}{{ all }}">
          {{ bb.title }}</a></h3>
          <div>{{ bb.content }}</div>
          <p class="text-right font-weight-bold">{{ bb.price }} руб.</p>
          <p class="text-right font-italic">{{ bb.created_at }}</p>
        </div>
    </li>
    {% endfor %}
</ul>
{% bootstrap_pagination page url=keyword %}
{% endif %}
{% endblock %}

bboard/main/templates/main/change_user_info.html
{% extends "layout/basic.html" %}

{% load bootstrap4 %}

{% block title %}Правка личных данных{% endblock %}

{% block content %}
<h2>Правка личных данных пользователя {{ user.username }}</h2>
<form method="post">
    {% csrf_token %}
    {% bootstrap_form form layout='horizontal' %}
    {% buttons submit='Сохранить' %}{% endbuttons %}
</form>
{% endblock %}

bboard/main/templates/main/index.html
{% extends "layout/basic.html" %}

{% load thumbnail %}
{% load static %}

{% block content %}
<h2>Последние 10 объявлений</h2>
{% if bbs %}
<ul class="list-unstyled">
    {% for bb in bbs %}
    <li class="media my-5 p-3 border">
        {% url 'main:detail' rubric_pk=bb.rubric.pk pk=bb.pk as url %}
        <a href="{{ url }}{{ all }}">
        {% if bb.image %}
        <img class="mr-3" src="{% thumbnail bb.image 'default' %}">
        {% else %}
        <img class="mr-3" src="{% static 'main/empty.jpg' %}">
        {% endif %}
        </a>
        <div class="media-body">
          <h3><a href="{{ url }}{{ all }}">
          {{ bb.title }}</a></h3>
          <div>{{ bb.content }}</div>
          <p class="text-right font-weight-bold">{{ bb.price }} руб.</p>
          <p class="text-right font-italic">{{ bb.created_at }}</p>
        </div>
    </li>
    {% endfor %}
</ul>
{% endif %}
{% endblock %}

bboard/main/templates/main/login.html
{% extends "layout/basic.html" %}

{% load bootstrap4 %}

{% block title %}Вход{% endblock %}

{% block content %}
<h2>Вход</h2>
{% if user.is_authenticated %}
<p>Вы уже выполнили вход.</p>
{% else %}
<form method="post">
    {% csrf_token %}
    {% bootstrap_form form layout='horizontal' %}
    <input type="hidden" name="next" value="{{ next }}">
    {% buttons submit='Войти' %}{% endbuttons %}
</form>
{% endif %}
{% endblock %}

bboard/main/templates/main/logout.html
{% extends "layout/basic.html" %}

{% block title %}Выход{% endblock %}

{% block content %}
<h2>Выход</h2>
<p>Вы успешно вышли с сайта.</p>
{% endblock %}

bboard/main/templates/main/password_complete.html
{% extends "layout/basic.html" %}

{% load bootstrap4 %}

{% block title %}Сброс пароля завершен{% endblock %}

{% block content %}
<h2>Сброс пароля завершен</h2>
<p>Для пользователя установлен новый пароль.</p>
<p><a href="{% url 'main:login' %}">Вход на сайт</a></p>
{% endblock %}

bboard/main/templates/main/password_confirm.html
{% extends "layout/basic.html" %}

{% load bootstrap4 %}

{% block title %}Ввод нового пароля{% endblock %}

{% block content %}
<h2>Ввод нового пароля пользователя</h2>
<form method="post">
    {% csrf_token %}
    {% bootstrap_form form layout='horizontal' %}
    {% buttons submit='Сохранить' %}{% endbuttons %}
</form>
{% endblock %}

bboard/main/templates/main/profile_bb_add.html
{% extends "layout/basic.html" %}

{% load bootstrap4 %}
{% block title %}Добавление объявления - Профиль пользователя{% endblock %}

{% block content %}
<h2>Добавление объявления</h2>
<form method="post" enctype="multipart/form-data">
    {% csrf_token %}
    {% bootstrap_form form layout='horizontal' %}
    {% bootstrap_formset formset layout='horizontal' %}
    {% buttons submit='Добавить' %}{% endbuttons %}
</form>
{% endblock %}

bboard/main/templates/main/profile_bb_chang.html
{% extends "layout/basic.html" %}

{% load bootstrap4 %}

{% block title %}Правка объявления - Профиль пользователя{% endblock %}

{% block content %}
<h2>Правка объявления</h2>
<form method="post" enctype="multipart/form-data">
    {% csrf_token %}
    {% bootstrap_form form layout='horizontal' %}
    {% bootstrap_formset formset layout='horizontal' %}
    {% buttons submit='Сохранить' %}{% endbuttons %}
</form>
{% endblock %}

bboard/main/templates/main/profile_bb_delete.html
{% extends "layout/basic.html" %}

{% block title %}Удаление объявления - Профиль пользователя{% endblock %}

{% block content %}
<h2>Удаление объявления</h2>
<div class="container-fluid mt-3">
    <div class="row">
        {% if bb.image %}
        <div class="col-md-auto"><img src="{{ bb.image.url }}" class="main-image"></div>
        {% endif %}
        <div class="col">
            <h2>{{ bb.title }}</h2>
            <p>{{ bb.content }}</p>
            <p class="font-weight-bold">{{ bb.price }} руб.</p>
            <p>{{ bb.contacts }}</p>
            <p class="text-right font-italic">Добавлено {{ bb.created_at }}</p>
        </div>
    </div>
</div>
<form method="post">
    {% csrf_token %}
    <input type="submit" value="Удалить">
</form>
{% endblock %}

bboard/main/templates/main/profile_bb_detail.html
{% extends "layout/basic.html" %}

{% block title %}{{ bb.title }} - Профиль пользователя{% endblock %}

{% block content %}
<div class="container-fluid mt-3">
    <div class="row">
        {% if bb.image %}
        <div class="col-md-auto"><img src="{{ bb.image.url }}"
        class="main-image"></div>
        {% endif %}
        <div class="col">
            <h2>{{ bb.title }}</h2>
            <p>{{ bb.content }}</p>
            <p class="font-weight-bold">{{ bb.price }} руб.</p>
            <p>{{ bb.contacts }}</p>
            <p class="text-right font-italic">Добавлено {{ bb.created_at }}</p>
        </div>
    </div>
</div>
{% if ais %}
<div class="d-flex justify-content-between flex-wrap mt-5">
    {% for ai in ais %}
    <div>
        <img class="additional-image" src="{{ ai.image.url }}">
    </div>
    {% endfor %}
</div>
{% endif %}
<p><a href="{% url 'main:profile' %}">Назад</a></p>
{% if comments %}
<div class="mt-5">
    {% for comment in comments %}
    <div class="my-2 p-2 border">
        <h5>{{ comment.author }}</h5>
        <p>{{ comment.content }}</p>
        <p class="text-right font-italic">{{ comment.created_at }}</p>
    </div>
    {% endfor %}
</div>
{% endif %}
{% endblock %}

bboard/main/templates/main/register_done.html
{% extends "layout/basic.html" %}

{% block title %}Регистрация завершена{% endblock %}

{% block content %}
<h2>Регистрация</h2>
<p>Регистрация пользователя завершена.</p>
<p>На адрес электронной почты, указанный пользователем, выслано письмо для
активации.</p>
{% endblock %}

bboard/main/templates/main/register_user.html
{% extends "layout/basic.html" %}

{% load bootstrap4 %}

{% block title %}Регистрация{% endblock %}

{% block content %}
<h2>Регистрация нового пользователя</h2>
<form method="post">
    {% csrf_token %}
    {% bootstrap_form form layout='horizontal' %}
    {% buttons submit='Зарегистрироваться' %}{% endbuttons %}
</form>
{% endblock %}